#include <pspsdk.h>
#include <time.h>
#include <pspiofilemgr.h>
#include <psprtc.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "fileOperation.h"

struct homebrew Dummylist[MAX_HB];

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Get extension of a file:
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void getExtension(char *fileName, char *extension, int extMaxLength){
    int i = 0;
    int j = 0;
    int count = 0;
    for (i = strlen(fileName) - 1; i >= 0; i--){
        if (fileName[i] == '.'){
            if (i == strlen(fileName) - 1)
                return;
            for (j = i+1; j < strlen(fileName); j++){
                extension[count++] = toupper(fileName[j]);
                if (count > extMaxLength)
                    return;
            }
            extension[count] = '\0';
            return;
        }
    }
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Get categories list:
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int getCATList(struct category *CATlist){
    int dirScanned = 0;
    int dirToScanNumber = 0;
    int openedDir = 0;
    int CATfound = 0;
    static SceIoDirent oneDir;
    char dirToScan[10][262];

    strcpy(dirToScan[0], "ms0:/PSP/GAME");
    strcpy(dirToScan[1], "ms0:/PSP/GAME150");
    strcpy(dirToScan[2], "ms0:/PSP/GAME5XX");//add by mascii
    strcpy(dirToScan[3], "ms0:/ISO");
    //dirToScanNumber = 8;
    dirToScanNumber = 4;

    if(getHBList(Dummylist, "Uncategorized") != 0){
        strcpy(CATlist[0].name, "Uncategorized");
        CATfound++;
    }

    while (dirScanned < dirToScanNumber){
        openedDir = sceIoDopen(dirToScan[dirScanned]);
        if (openedDir < 0){
            dirScanned++;
            continue;
        }
        while (1){
            memset(&oneDir, 0, sizeof(SceIoDirent));
            if (sceIoDread(openedDir, &oneDir) <= 0)
                break;
            if (!strcmp(oneDir.d_name, ".") || !strcmp(oneDir.d_name, ".."))
                continue;

            //Directory (CAT):
            if (FIO_S_ISDIR(oneDir.d_stat.st_mode)){
                //Check for 1.50 and "CAT_"
                int j;
                char check[5] = "";
                for (j=0; j<4; j++)
                    check[j] = oneDir.d_name[j];
                if (strcmp(check, "CAT_"))
                    continue;

                char categoryname[262] = "";
                int t;
                for (t=4; t<strlen(oneDir.d_name); t++)
                    categoryname[t-4] = oneDir.d_name[t];

		int u = 0;
		int v = 0;
                for (; u<CATfound; u++){
                    if(!strcmp(categoryname,CATlist[u].name)){
                        v = 1;
                        break;
                    }
                }
                if(!v){
                    strcpy(CATlist[CATfound].name, categoryname);
                    CATfound++;
                }

            }
        }
        sceIoDclose(openedDir);
        dirScanned++;
    }

    return CATfound;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Get homebrew list:
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int getHBList(struct homebrew *HBlist, const char *categoryname){
    int dirScanned = 0;
    int dirToScanNumber = 0;
    int openedDir = 0;
    int HBfound = 0;
    static SceIoDirent oneDir;
    char dirToScan[10][262];
    char fullName[262];
    SceIoStat stats;

    strcpy(dirToScan[0], "ms0:/PSP/GAME");
    strcpy(dirToScan[1], "ms0:/PSP/GAME150");
    strcpy(dirToScan[2], "ms0:/PSP/GAME5XX");//add by mascii
    strcpy(dirToScan[3], "ms0:/ISO");
    //dirToScanNumber = 8;
    dirToScanNumber = 4;
    if(!(strstr(categoryname, "Uncategorized"))){
        int t;
        for (t=0; t<dirToScanNumber; t++){
            strcat(dirToScan[t],"/CAT_");
            strcat(dirToScan[t],categoryname);
        }
    }

    while (dirScanned < dirToScanNumber){
        openedDir = sceIoDopen(dirToScan[dirScanned]);
        if (openedDir < 0){
            dirScanned++;
            continue;
        }
        while (1){
            memset(&oneDir, 0, sizeof(SceIoDirent));
            if (sceIoDread(openedDir, &oneDir) <= 0)
                break;
            if (!strcmp(oneDir.d_name, ".") || !strcmp(oneDir.d_name, ".."))
                continue;
        	if (dirToScan[dirScanned][strlen(dirToScan[dirScanned])-1] != '/')
                sprintf(fullName, "%s/%s", dirToScan[dirScanned], oneDir.d_name);
            else
                sprintf(fullName, "%s%s", dirToScan[dirScanned], oneDir.d_name);

            //Directory (HB):
            if (FIO_S_ISDIR(oneDir.d_stat.st_mode) && (strstr(dirToScan[dirScanned], "ms0:/ISO") == NULL)){
                //Check for 1.50 and "CAT_"
                int j;
                char check[8] = "";
                for (j=0; j<7; j++)
                    check[j] = oneDir.d_name[j];
                if (!stricmp(check, "__SCE__") || !(strstr(check, "CAT_") == NULL))
                    continue;
                sceIoGetstat(fullName, &stats);
                strcpy(HBlist[HBfound].name, oneDir.d_name);
                strcpy(HBlist[HBfound].path, fullName);
                HBlist[HBfound].dateModify = stats.st_mtime;
                sprintf(HBlist[HBfound].dateForSort, "%4.4i%2.2i%2.2i%2.2i%2.2i%2.2i%6.6i", stats.st_mtime.year, stats.st_mtime.month, stats.st_mtime.day, stats.st_mtime.hour, stats.st_mtime.minute, stats.st_mtime.second, stats.st_mtime.microsecond);
                HBfound++;
            //Files (ISOS):
            }else if (FIO_S_ISREG(oneDir.d_stat.st_mode)){
                char ext[4];
                getExtension(fullName, ext, 3);
                if ((!stricmp(ext, "CSO") || !stricmp(ext, "ISO"))){
                    strcpy(HBlist[HBfound].name, oneDir.d_name);
                    sceIoGetstat(fullName, &stats);
                    strcpy(HBlist[HBfound].path, fullName);
                    HBlist[HBfound].dateModify = stats.st_mtime;
                    sprintf(HBlist[HBfound].dateForSort, "%4.4i%2.2i%2.2i%2.2i%2.2i%2.2i%6.6i", stats.st_mtime.year, stats.st_mtime.month, stats.st_mtime.day, stats.st_mtime.hour, stats.st_mtime.minute, stats.st_mtime.second, stats.st_mtime.microsecond);
                    HBfound++;
                }
            }
        }
        sceIoDclose(openedDir);
        dirScanned++;
    }
    
    //Sort list:
    int i = 0;
    while (i < HBfound){
        if (i == 0 || stricmp(HBlist[i-1].dateForSort, HBlist[i].dateForSort) >= 0)
            i++;
        else{
            struct homebrew tmp = HBlist[i];
            HBlist[i] = HBlist[i-1];
            HBlist[--i] = tmp;
        }
    }
    return HBfound;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Move HB up:
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int moveHBup(int index, struct homebrew *HBlist){
    if (index > 0){
        struct homebrew tmp = HBlist[index];
        HBlist[index] = HBlist[index - 1];
        HBlist[index - 1] = tmp;
    }
    return 0;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Move HB down:
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int moveHBdown(int index, struct homebrew *HBlist){
    struct homebrew tmp = HBlist[index];
    HBlist[index] = HBlist[index + 1];
    HBlist[index + 1] = tmp;
    return 0;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Move HB Top:
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int moveHBTop(int index, struct homebrew *HBlist){

	int i;

    if (index > 0){
        struct homebrew tmp = HBlist[index];
		for (i=index; i>0; i--){
	        HBlist[i] = HBlist[i-1];
		}
		HBlist[0] = tmp;
    }
    return 0;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Move HB Bottom:
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int moveHBBottom(int index, int HBcount, struct homebrew *HBlist){

	int i;

    if (index < HBcount -1){
        struct homebrew tmp = HBlist[index];
		for (i=index; i<=HBcount -1; i++){
	        HBlist[i] = HBlist[i+1];
		}
		HBlist[HBcount -1] = tmp;
    }
    return 0;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Save HB list:
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int saveHBlist(struct homebrew *HBlist, int HBcount){
    int i = 0;
    SceIoStat stat;
    ScePspDateTime start;
	pspTime rtime;

	sceRtcGetCurrentClockLocalTime(&rtime);

    start.year = rtime.year;//2008;
    start.month = rtime.month;//01;
    start.day = rtime.day;//01;
    start.hour = rtime.hour;
    start.minute = rtime.minutes;
    start.second = rtime.seconds;
    start.microsecond = rtime.microseconds;


    memset(&stat, 0, sizeof(SceIoStat));
    stat.st_mode = 0777;
    
    for (i=HBcount - 1; i>=0; i--){
        stat.st_mtime = start;//MODIFICATION TIME
        stat.st_ctime = start;//CREATION TIME
        sceIoChstat(HBlist[i].path, &stat, 0x1);
        sceIoChstat(HBlist[i].path, &stat, 0x20);
        sceIoChstat(HBlist[i].path, &stat, 0x8);
/*
		memset(&rtime, 0, sizeof(pspTime));
		sceRtcGetCurrentClockLocalTime(&rtime);
		start.year = rtime.year;
		start.month = rtime.month;
		start.day = rtime.day;
*/
		if ((start.hour == 23) && (start.minute == 59) && (start.second >= 50) && (start.second <= 59)){
			start.hour = 00;
			start.minute = 00;
			start.second += 10;
			start.day++;
			if (start.day == 31){
				if ((start.month == 4) || (start.month == 6) || (start.month == 9) || (start.month == 11)){
					start.month++;
					start.day = 01;
				}
			}
			if (start.day > 31){
				start.month++;
				if (start.month > 12){
					start.year++;
					start.month = 01;
				}
				start.day = 01;
			}
			if ((start.month == 2) && (start.day == 29)){
				if(start.year%400 == 0 || (start.year%4 == 0 && start.year%100 != 0)){
				}
				else{
					start.month++;
					start.day=01;
				}
			}
		}
		else{
			if (start.second < 50){
				start.second +=10;
			}
			else{
				if (start.minute < 59){
					start.minute++;
				}
				else{
					start.hour++;
					start.minute=00;
				}
				start.second=00;
			}
		}
    }
    return 0;
}
